import javafx.application.*;
import javafx.scene.*;
import javafx.scene.layout.*;
import javafx.scene.control.*;
import javafx.scene.paint.*;
import javafx.scene.image.*;
import javafx.scene.effect.*;
import javafx.scene.text.*;
import javafx.scene.input.*;
import javafx.scene.canvas.*;
import javafx.scene.shape.*;
import javafx.stage.*;
import javafx.event.*;
import javafx.geometry.*;
import javafx.collections.*;

public class Hiragana extends Application{

    // nhANZXϐ
    private TextField in;
    private Label lb2;
    private Canvas cv;
    private int i=1;
    private GraphicsContext gc;
    private double nx, ny;
    private int size = 5;
    private Color clr = Color.BLACK;

    public void start(Stage st) throws Exception{

        //i̐
        in = new TextField();
        in.setPromptText("F");

        Label lb0 = new Label("{ȂĂЂ炪Ȃ̗K悤I");
        Label lb1 = new Label("Ђ炪Ȍ");
        lb2 = new Label(" ");
        lb0.setTextFill(Color.MIDNIGHTBLUE);
        lb2.setTextFill(Color.RED);

        Font ft = new Font(18);
        lb0.setFont(ft);


        Button bt1 = new Button("");
        Button bt2 = new Button("<");
        Button bt3 = new Button(">");
        Button bt4 = new Button("NA");
        bt2.setPrefSize(25, 100);
        bt3.setPrefSize(25, 100);
        
        bt2.setId("prev");
        bt3.setId("next");
        bt4.setId("clear");

        cv = new Canvas(230, 230);
        gc = cv.getGraphicsContext2D();
        gc.setFill(Color.WHITE);
        gc.fillRect(0, 0, cv.getWidth(), cv.getHeight());
        Image img = new Image(i + ".png");
		gc.drawImage(img, 0, 0);

        //j[̐
        MenuBar mb = new MenuBar();
        mb.setBackground(new Background(new BackgroundFill(Color.LIGHTGREY, null, null)));
        Menu m1 = new Menu("y̑");
        Menu m2 = new Menu("y̐F");
        
        //j[ڂ̐
        RadioMenuItem mi1 = new RadioMenuItem("");
        RadioMenuItem mi2 = new RadioMenuItem("");
        RadioMenuItem mi3 = new RadioMenuItem("");
        mi1.setId("s");
        mi2.setId("m");
        mi3.setId("l");
        ToggleGroup tg1 = new ToggleGroup();
        mi1.setToggleGroup(tg1);
        mi2.setToggleGroup(tg1);
        mi3.setToggleGroup(tg1);
        mi1.setSelected(true);

        RadioMenuItem mi4 = new RadioMenuItem("");
        RadioMenuItem mi5 = new RadioMenuItem("");
        RadioMenuItem mi6 = new RadioMenuItem("");
        mi4.setId("black");
        mi5.setId("red");
        mi6.setId("blue");
        ToggleGroup tg2 = new ToggleGroup();
        mi4.setToggleGroup(tg2);
        mi5.setToggleGroup(tg2);
        mi6.setToggleGroup(tg2);
        mi4.setSelected(true);

        //j[̑gݗ
        ObservableList<Menu> lstm = mb.getMenus();
        lstm.add(m1);
        lstm.add(m2);
        ObservableList<MenuItem> lstmi1 = m1.getItems();
        lstmi1.add(mi1);
        lstmi1.add(mi2);
        lstmi1.add(mi3);
        ObservableList<MenuItem> lstmi2 = m2.getItems();
        lstmi2.add(mi4);
        lstmi2.add(mi5);
        lstmi2.add(mi6);

        //j[nh̓o^
        MenuEventHandler menuhandler = new MenuEventHandler();
        m1.addEventHandler(ActionEvent.ANY, menuhandler);
        m2.addEventHandler(ActionEvent.ANY, menuhandler);

        //{^nh̓o^
        bt1.addEventHandler(ActionEvent.ANY, new SearchEventHandler());
        ButtonEventHandler buttonhandler = new ButtonEventHandler();
        bt2.addEventHandler(ActionEvent.ANY, buttonhandler);
        bt3.addEventHandler(ActionEvent.ANY, buttonhandler);
        bt4.addEventHandler(ActionEvent.ANY, buttonhandler);

        //}EXnh̓o^
        MouseEventHandler mousehandler = new MouseEventHandler();
		cv.addEventHandler(MouseEvent.ANY, mousehandler);

        //CAEg̏
        GridPane gp = new GridPane();
        gp.add(lb1, 0, 0);
        gp.add(in, 1, 0);
        gp.add(bt1, 2, 0);
    
        HBox hb = new HBox();
        ObservableList<Node> lsth = hb.getChildren();
        lsth.add(bt2);
        lsth.add(cv);
        lsth.add(bt3);

        VBox vb = new VBox();
        ObservableList<Node> lstv = vb.getChildren();
        lstv.add(lb0);
        lstv.add(gp);
        lstv.add(lb2);
        lstv.add(hb);
        lstv.add(bt4);

        BorderPane bp = new BorderPane();
        bp.setTop(mb);
        bp.setCenter(vb);
        bp.setBackground(null);

        //CAEg̊eݒ
        gp.setHgap(5);
        hb.setAlignment(Pos.CENTER);
        hb.setSpacing(10);
        vb.setPadding(new Insets(10));
        vb.setSpacing(5);

        //V[̐ݒ
        Scene sc = new Scene(bp);
        sc.setFill(Color.ALICEBLUE);

        //Xe[W̐ݒƕ\
        st.setScene(sc);
        st.setTitle("Ђ炪ȗKAv");
        st.show();
    }

    //j[̃Cxgnh̐ݒ
    private class MenuEventHandler implements EventHandler<ActionEvent>{
        public void handle(ActionEvent e){
            RadioMenuItem mi = (RadioMenuItem)e.getTarget();
            String str = mi.getId();
            if(str.equals("s")){
                size = 5;
            }else if(str.equals("m")){
                size = 10;
            }else if(str.equals("l")){
                size = 15;
            }

            if(str.equals("black")){
                clr = Color.BLACK;
            }else if(str.equals("red")){
                clr = Color.RED;
            }else if(str.equals("blue")){
                clr = Color.BLUE;
            }
        }
    }

    //LoX̏̐ݒ
    private void sethiragana(){
        gc.setFill(Color.WHITE);
            gc.fillRect(0, 0, cv.getWidth(), cv.getHeight());
            Image img = new Image(i + ".png");
	        gc.drawImage(img, 0, 0);
    }
    private void draw(){
		gc.setFill(clr);
		gc.fillOval(nx-(size/2), ny-(size/2), size, size);
	}

    //{^̃Cxgnh̐ݒ
    private class ButtonEventHandler implements EventHandler<ActionEvent>
    {
        public void handle(ActionEvent e)
        {
            Button bt = (Button)e.getTarget();
            String id = bt.getId();
            if(id == "prev"){
                if(i==1){
                    i = 46;
                }else{
                    i--;
                }
            }
            if(id == "next"){
                if(i==46){
                    i = 1;
                }else{
                    i++;   
                }
            }
            if(id == "clear"){

            }
            sethiragana();
        }
    }

    private class SearchEventHandler implements EventHandler<ActionEvent>
    {
        public void handle(ActionEvent e)
        {
            String search = in.getText();
            String[] hira = {"", "", "", "", "", "", "", "", "", "",
                             "", "", "", "", "", "", "", "", "", "",
                             "", "", "", "", "", "", "", "", "", "",
                             "", "", "", "", "", "",       "",       "", 
                             "", "", "", "", "", "",       "",       ""};

            for(int s = 1; s < 47; s++){
                if(search.equals(hira[s-1])){
                    lb2.setText("");
                    i = s;
                    sethiragana();
                    break;
                }else{
                    lb2.setText("Ђ炪ȂP͂Ă");
                }
            }
        }
    }

    //}EX̃Cxgnh̐ݒ
    
    private class MouseEventHandler implements EventHandler<MouseEvent>{
		public void handle(MouseEvent e){
			EventType<? extends MouseEvent> type = e.getEventType();
			if(type == MouseEvent.MOUSE_CLICKED){
				nx = e.getX();
				ny = e.getY();
				draw();
			}
            if(type == MouseEvent.MOUSE_DRAGGED){
				nx = e.getX();
				ny = e.getY();
				draw();
			}
		}
	}

    public static void main(String[] args)
    {
        launch(args);
    }
}